      subroutine cyclic_symmetry(theta_symm, phi_symm, omega_symm,
     $     theta, phi, omega, symm_code, num_symm)

C     For a given orientation, generate the full set of dihedral
C     symmetry related orientations

      implicit none

      integer, intent(in) :: num_symm, symm_code
      real, intent(in)    :: theta, phi, omega
      real, intent(out)   :: theta_symm(num_symm), phi_symm(num_symm),
     $     omega_symm(num_symm)

      integer i, half_symm
      real unit
      
      unit = 360.0 / real(num_symm)

      do i = 1, num_symm
         theta_symm(i) = theta
         phi_symm(i)   = phi + real(i-1)*unit
         omega_symm(i) = omega
      enddo

C     Get phi into range (-180,180)
      do i = 1, num_symm
         phi_symm(i) = mod(phi_symm(i), 360.0)
         if (phi_symm(i) > 180.0) then
            phi_symm(i) = phi_symm(i) - 360.0
         endif
         if (phi_symm(i) < -180.0) then
            phi_symm(i) = phi_symm(i) + 360.0
         endif
      enddo

      return
      end subroutine cyclic_symmetry
