      subroutine fix_defocus(def_maj, def_min, maj_ang)

C     This routine guarantees that the defocus values are given as
C     maximum defocus, minimum defocus, astigmatism angle as
C     angle between x-axis and direction with maximum defocus.
C     The astigmatism angle is constrained between 0 and 180 degrees

      implicit none

      real, intent(inout) :: def_maj, def_min, maj_ang
      
      real :: def_aux
      
      if ( def_maj < def_min ) then
      
         def_aux = def_min
         def_min = def_maj
         def_maj = def_aux
         maj_ang = maj_ang + 90
         
      endif
      
      do while ( maj_ang >= 180. )
          maj_ang = maj_ang - 180.
      enddo  
      
      do while ( maj_ang < 0. )
          maj_ang = maj_ang + 180.
      enddo
      
      return
      end subroutine fix_defocus
