#include "data.h"


char* convert_data(char *data, int size, int indt, int outdt) {

    int ret = -1;
    char* out_data;
    
    if (indt == UINT) {
        if (outdt == INT) {
            out_data = uint2int(data, size);
            ret = 1;
        }
    }
    
    if (ret < 0) {
        fprintf(stderr,"Error(convert_data): conversion from %d to %d not supported!\n",indt,outdt);
        return((char*) NULL);
    }

    return out_data;
        
}

char* uint2int(char *data, int size) {

    int i;
    float maxval, minval;
    maxval = 0.;
    minval = (float) UINT_MAX;
    
    unsigned int * d = (unsigned int *) data;
    for (i=0; i<size; i++) {
    	if ((float) d[i] > maxval) {
    	    maxval = (float) d[i];
    	} else if ((float) d[i] < minval) {
    	    minval = (float) d[i];
    	} 
    }

    int * outdata = (int *) data;
    if ((unsigned int) maxval > INT_MAX) {
        int shift = (int) (maxval - INT_MAX);
        for (i=0; i<size; i++) {
    	    outdata[i] = (int) (data[i] - shift);
    	}
    }
    
    return (char *) outdata;
} 
